package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.kc.ImCkwpkwp;
import com.dsic.gj_erp.bean.kc.SlKc;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.bean.sy.Dm_zhbmp;
import com.dsic.gj_erp.dao.sy.Dm_zhbmpRepository;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.exception.ServiceException;
import com.dsic.gj_erp.mapper.jhgk.DmYdjhMapper;
import com.dsic.gj_erp.mapper.kc.ImCkwpkwpMapper;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.kc.ImCkwpkwpService;
import com.dsic.gj_erp.service.pgd.PgdSljhService;
import com.dsic.gj_erp.service.sy.SYService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器  // 入库批号
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdSljh")
public class PgdSljhController {
    
    
    @Autowired
    PgdSljhService pgdSljhService;

    @Autowired
    DmYdjhService dmYdjhService;

    @Autowired
    DmYdjhMapper dmYdjhMapper;


    @Autowired
    ImCkwpkwpMapper imCkwpkwpMapper;
    @Autowired
    ImCkwpkwpService  imCkwpkwpService;

//    @Autowired
//    DmCzjbbService dmCzjbbService;
    @Autowired
    DmCbxxpService dmCbxxpService;




    @Autowired
    SYService syService;

    @Autowired
    Dm_zhbmpRepository dm_zhbmpRepository;

    @PostMapping("/slPrint")
    @ResponseBody
    @AuthFunction
    public ResultBean slPrint(HttpServletRequest req, @RequestBody List<SlKc> list) throws Exception, CustomException {
                //ls_lsh = F_GETPJH("MM",'00',"MSMS")
        String id = syService.f_getpjh("MM", "00", "MSMS");
        //dw_1.object.sllsh[ll_ii] = ls_lsh
        //dw_1.object.dyry[ll_ii] = gs_user
        //dw_1.object.dyrq[ll_ii] = ls_datetime
        List<DmYdjh>ydupList=new ArrayList<>();
        List<ImCkwpkwp>ckupList=new ArrayList<>();
            for(SlKc slKc: list){
                if(StringUtils.isBlank(slKc.getSllsh())){
                    ImCkwpkwp imCkwpkwp = new ImCkwpkwp();
                    imCkwpkwp.setCkh(slKc.getCKH());
                    imCkwpkwp.setWph(slKc.getWPH());
                    imCkwpkwp.setKwh(slKc.getKWH());
                    imCkwpkwp.setNbsbm(slKc.getNBSBM());
                    imCkwpkwp.setSllsh(id);
                    imCkwpkwp.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                    imCkwpkwp.setDyry((String) req.getAttribute("yhms"));
                    ckupList.add(imCkwpkwp);
                   // slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                }
                if(StringUtils.isNotBlank(slKc.getYdid())){
                    DmYdjh ydjh =new DmYdjh();
                    // 库存主键 没存
                    ydjh.setId(slKc.getYdid());
                    ydjh.setZt("11");
                    ydjh.setSllsh(id);
                    ydjh.setSldrrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                    ydjh.setSldrry((String) req.getAttribute("yhms"));
                    ydupList.add(ydjh);
                }
            }

                dmYdjhService.updateBatchById(ydupList);
                imCkwpkwpService.updateBatchByMultiId(ckupList);


        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        List<Dm_zhbmp> zylxs = dm_zhbmpRepository.findByBMLB("zylx");
        List<Dm_zhbmp> pwwzs = dm_zhbmpRepository.findByBMLB("pwwz");
        List<Dm_zhbmp> dhql = dm_zhbmpRepository.findByBMLB("DHQL");
        List<Dm_zhbmp> wpzts = dm_zhbmpRepository.findByBMLB("WPZT");

        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> zylxMap = zylxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> pwwzMap = pwwzs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> dhqlMap = dhql.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> wpztMap = wpzts.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Integer  sh=1;
        for(SlKc slKc: list){
            slKc.setXh(sh);
            sh++;
            slKc.setZYLX(zylxMap.get(slKc.getZYLX()));
            slKc.setSLDW(qgKwMap.get(slKc.getSLDW()));
            slKc.setWPZT(wpztMap.get(slKc.getWPZT()));

        }
        int ceil = (int) (Math.ceil((double) list.size() / 40));
        List<SlKc> slKcList= new ArrayList<>();
        if(ceil>1){
            for(int i=0;i<ceil;i++){
                SlKc slKc =new SlKc();
                slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                if (ceil - i == 1){
                    slKc.setList(list.subList(i*40,list.size()));
                }else{
                    int num =i*40+40;

                    slKc.setList(list.subList(i*40,num));
                }
                slKcList.add(slKc);
            }
        }else{
            SlKc slKc =new SlKc();
            slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            slKc.setList(list);
            slKcList.add(slKc);
        }



       return  new ResultBean(slKcList);


    }



    @PostMapping("/slPrintD")
    @ResponseBody
    public ResultBean slPrintD(HttpServletRequest req, @RequestBody List<SlKc> list) throws Exception, CustomException {
        //ls_lsh = F_GETPJH("MM",'00',"MSMS")
        String id = syService.f_getpjh("MM", "00", "MSMS");
        //dw_1.object.sllsh[ll_ii] = ls_lsh
        //dw_1.object.dyry[ll_ii] = gs_user
        //dw_1.object.dyrq[ll_ii] = ls_datetime
        List<DmYdjh>ydupList=new ArrayList<>();
        List<ImCkwpkwp>ckupList=new ArrayList<>();
        for(SlKc slKc: list){
            if(StringUtils.isBlank(slKc.getSllsh())){
                ImCkwpkwp imCkwpkwp = new ImCkwpkwp();
                imCkwpkwp.setCkh(slKc.getCKH());
                imCkwpkwp.setWph(slKc.getWPH());
                imCkwpkwp.setKwh(slKc.getKWH());
                imCkwpkwp.setNbsbm(slKc.getNBSBM());
                imCkwpkwp.setSllsh(id);
                imCkwpkwp.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                imCkwpkwp.setDyry((String) req.getAttribute("yhms"));
                ckupList.add(imCkwpkwp);
                // slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            }

        }


        //imCkwpkwpService.updateBatchByMultiId(ckupList);


        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        List<Dm_zhbmp> zylxs = dm_zhbmpRepository.findByBMLB("zylx");
        List<Dm_zhbmp> pwwzs = dm_zhbmpRepository.findByBMLB("pwwz");
        List<Dm_zhbmp> dhql = dm_zhbmpRepository.findByBMLB("DHQL");
        List<Dm_zhbmp> wpzts = dm_zhbmpRepository.findByBMLB("WPZT");

        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> zylxMap = zylxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> pwwzMap = pwwzs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> dhqlMap = dhql.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> wpztMap = wpzts.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Integer  sh=1;
        for(SlKc slKc: list){
            slKc.setXh(sh);
            sh++;
            slKc.setZYLX(zylxMap.get(slKc.getZYLX()));
            slKc.setSLDW(qgKwMap.get(slKc.getSLDW()));
            slKc.setWPZT(wpztMap.get(slKc.getWPZT()));

        }
        int ceil = (int) (Math.ceil((double) list.size() / 40));
        List<SlKc> slKcList= new ArrayList<>();
        if(ceil>1){
            for(int i=0;i<ceil;i++){
                SlKc slKc =new SlKc();
                slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                if (ceil - i == 1){
                    slKc.setList(list.subList(i*40,list.size()));
                }else{
                    int num =i*40+40;

                    slKc.setList(list.subList(i*40,num));
                }
                slKcList.add(slKc);
            }
        }else{
            SlKc slKc =new SlKc();
            slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            slKc.setList(list);
            slKcList.add(slKc);
        }



        return  new ResultBean(slKcList);


    }



    @PostMapping("/slPrintqx")
    @ResponseBody
    public ResultBean slPrintqx(HttpServletRequest req, @RequestBody List<SlKc> list) throws Exception, CustomException {
        //ls_lsh = F_GETPJH("MM",'00',"MSMS")
       // String id = syService.f_getpjh("MM", "00", "MSMS");
        //dw_1.object.sllsh[ll_ii] = ls_lsh
        //dw_1.object.dyry[ll_ii] = gs_user
        //dw_1.object.dyrq[ll_ii] = ls_datetime
        List<DmYdjh>ydupList=new ArrayList<>();
        List<ImCkwpkwp>ckupList=new ArrayList<>();
        for(SlKc slKc: list){
            if(StringUtils.isNotBlank(slKc.getSllsh())){
                ImCkwpkwp imCkwpkwp = new ImCkwpkwp();
                imCkwpkwp.setCkh(slKc.getCKH());
                imCkwpkwp.setWph(slKc.getWPH());
                imCkwpkwp.setKwh(slKc.getKWH());
                imCkwpkwp.setNbsbm(slKc.getNBSBM());
                imCkwpkwp.setSllsh("");
                imCkwpkwp.setDyrq("");
                imCkwpkwp.setDyry("");
                ckupList.add(imCkwpkwp);
                // slKc.setDyrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            }
            if(StringUtils.isNotBlank(slKc.getYdid())){
                DmYdjh ydjh =new DmYdjh();
                // 库存主键 没存
                ydjh.setId(slKc.getYdid());
                ydjh.setZt("2");
                ydupList.add(ydjh);
            }
        }

        dmYdjhService.updateBatchById(ydupList);
        imCkwpkwpService.updateBatchByMultiId(ckupList);



        return  new ResultBean();

    }


    @PostMapping("/getKcAndSljh")
    @ResponseBody
    public ResultBean getKcAndSljh(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {


        // 查询库存
        List<SlKc> slkcs = imCkwpkwpMapper.slxxKcList(map);

        QueryWrapper<DmYdjh> qw =new QueryWrapper<>();
        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"dc_ch",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"dc_pl",(String)map.get("pl"));
        // 库存标识 不等于 01 没有匹配上



            if(map.get("rqopt").equals("01")){
                qw.ne("isnull(ZT,'')","11");
            }else if(map.get("rqopt").equals("02")) {
                qw.eq("isnull(ZT,'')","11");
            }
        qw.orderBy(true,true,"czbh","pl","fd");
       // List<DmYdjh> ydjhs = dmYdjhService.list(qw);
        // 查询上料计划
        Map retrunMap =new HashMap();
        retrunMap.put("slkcs",slkcs);
        retrunMap.put("ydjhs",null);
        return new ResultBean(retrunMap);

    }



    @PostMapping("/getKcAndSljh1")
    @ResponseBody
    public ResultBean getKcAndSljh1(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {


        // 查询库存
        //List<SlKc> slkcs = imCkwpkwpMapper.slxxKcList(map);

        QueryWrapper<DmYdjh> qw =new QueryWrapper<>();
        qw.eq(StrUtil.isNotEmpty((String)map.get("xqdcch")),"dc_ch",(String)map.get("xqdcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("xqpl")),"dc_pl",(String)map.get("xqpl"));
        // 库存标识 不等于 01 没有匹配上



        if(map.get("rqopt").equals("01")){
            qw.eq("isnull(ZT,'')","2").eq("isnull(slkcdw,'')","");
        }else if(map.get("rqopt").equals("02")) {
            qw.eq("isnull(ZT,'')","2").ne("isnull(slkcdw,'')","");
        }else if(map.get("rqopt").equals("03")) {
            qw.eq("isnull(ZT,'')","11");
        }

         List<DmYdjh> ydjhs = dmYdjhService.list(qw);
        // 查询上料计划
        List<DmCbxxp> czList = dmCbxxpService.list();
        for(DmYdjh dmYdjh :ydjhs){
            String cjs="";
            DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(dmYdjh.getDcCh())).findFirst().orElse(null);

            if(null!=dmCzjbb){
                cjs=dmCzjbb.getCjs();
                dmYdjh.setWpxh1(cjs+dmYdjh.getWpxh());
            }
        }
        return new ResultBean(ydjhs);

    }


    @PostMapping("/getydjhByid")
    @ResponseBody
    public ResultBean getydjhByid(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {


        // 查询库存
        List<DmYdjh> list = dmYdjhService.list(new QueryWrapper<DmYdjh>().eq("id", (String) map.get("id")));


        return new ResultBean(list);

    }

    @PostMapping("kcAdnSlBd")
    @ResponseBody
    public ResultBean kcAdnSlBd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);
        String str1= JSON.toJSONString(map.get("data2"));
        List<DmYdjh>ydjhs= JSONObject.parseArray(str1, DmYdjh.class);

        List<DmCbxxp> czList = dmCbxxpService.list();
        List<DmYdjh>ydupList=new ArrayList<>();
        List<SlKc>ckupList=new ArrayList<>();
        // 进行比对
        for(SlKc slKc :slKcs){
            // 获取船级社
            String cjs="";
            DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(slKc.getDCCH())).findFirst().orElse(null);

            if(null!=dmCzjbb){
                cjs=dmCzjbb.getCjs();
            }
            String cjs1=cjs;
            DmYdjh dmYdjh = ydjhs.stream()
                .filter(fst -> fst.getDcCh().equalsIgnoreCase(slKc.getDCCH())
                        &&StringUtils.isNotBlank(fst.getWpgg())
                        &&  StringUtils.isNotBlank(fst.getWpxh())
                    && fst.getWpgg().equalsIgnoreCase(slKc.getWPGG())
                    && (fst.getWpxh().equalsIgnoreCase(slKc.getWPXH())
                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(slKc.getWPXH()))
                    )
                .findFirst()
                .orElse(null);

            if(null!=dmYdjh){
                System.out.println("slKc = " + slKc);
                dmYdjh.setSlkcdw(slKc.getKWH());
                System.out.println(slKc.getCFCS1()+dmYdjh.getId());
                dmYdjh.setSlcs(slKc.getCFCS1());
                dmYdjh.setSlxhth(slKc.getGCDDH());
                dmYdjh.setSlhth(slKc.getDcFd());
                dmYdjh.setSlwlh(slKc.getWPH());
                dmYdjh.setNbsbm(slKc.getNBSBM());
                dmYdjh.setSllph(slKc.getLPH());
                dmYdjh.setSlycldw((Integer) map.get("dw"));


//                ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
//                imCkwpkwp.setCkh(slKc.getCKH());
//                imCkwpkwp.setWph(slKc.getWPH());
//                imCkwpkwp.setKwh(slKc.getKWH());
//                imCkwpkwp.setNbsbm(slKc.getNBSBM());
//                imCkwpkwp.setYdid(dmYdjh.getId());
//                imCkwpkwp.setZych(dmYdjh.getDcCh());
//                imCkwpkwp.setZypl(dmYdjh.getDcPl());
//                imCkwpkwp.setZylx(dmYdjh.getZl());
//                imCkwpkwp.setSldw(dmYdjh.getKw());
                ydupList.add(dmYdjh);
               // ckupList.add(imCkwpkwp);

                slKc.setZYLX(getLx(dmYdjh.getLqlb(), dmYdjh.getZl(),dmYdjh.getTzbh()));
                slKc.setZYCH(dmYdjh.getDcCh());
                slKc.setZYPL(dmYdjh.getDcPl());
              //  slKc.setZYLX(dmYdjh.getZl());
                slKc.setSLDW(dmYdjh.getKw());
                slKc.setDHH(dmYdjh.getSljhrq());
                //slKc.setPwwz(dmYdjh.getKw());
                slKc.setYdid(dmYdjh.getId());
                ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
                ckupList.add(slKc);
            }
            // 填写  库存垛位 kwh  层数  cfcs1  小合同号 gcddh    合同工 dc_fd   物料号 wph    炉批号  lph

        }
        Map retrunMap =new HashMap();
        retrunMap.put("slkcs",ckupList);
        retrunMap.put("ydjhs",ydupList);
        return new ResultBean(retrunMap);
    }

    /**
     *
     * @param req
     * 需求船号  需求批量 流向 抛丸位置   切割跨位（根据 合同号生成） 备注
     * 根据 需求船号  需求批量 去 dm_ydjh 表中 查询  反写  库存垛位 上料层数，小合同号，合同号，物料号
     * 库存表 增加 dm_ydjh 表 id  （dm_ydjh 中 有数据 ）
     * @return
     * @throws Exception
     * @throws CustomException
     */
    @PostMapping("kcAdnSlBd1")
    @ResponseBody
    public ResultBean kcAdnSlBd1(HttpServletRequest req, @RequestBody List<SlKc> slKcs) throws Exception, CustomException {
             // 核对 没问题  有 yd id 说明核对 成功进行反写
        List<DmYdjh> ups = new ArrayList<>();
        List<ImCkwpkwp> ups1 = new ArrayList<>();
        List<DmCbxxp> czList = dmCbxxpService.list();


        for(SlKc slKc :slKcs){
            ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
            imCkwpkwp.setCkh(slKc.getCKH());
            imCkwpkwp.setWph(slKc.getWPH());
            imCkwpkwp.setKwh(slKc.getKWH());
            imCkwpkwp.setNbsbm(slKc.getNBSBM());
            imCkwpkwp.setYdid(slKc.getYdid());
            imCkwpkwp.setZych(slKc.getZYCH());
            imCkwpkwp.setZypl(slKc.getZYPL());
            imCkwpkwp.setZylx(slKc.getZYLX());
            imCkwpkwp.setSldw(slKc.getSLDW());
            imCkwpkwp.setPwwz(slKc.getPwwz());
            imCkwpkwp.setBz(slKc.getBZ());
            imCkwpkwp.setDhh(slKc.getDHH());
            imCkwpkwp.setDcTh(slKc.getDCTH());
            imCkwpkwp.setYdid(slKc.getYdid());

            if(StringUtils.isBlank(slKc.getYdid())){
                // 手工进行 批量了
                String cjs="";
            DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(slKc.getDCCH())).findFirst().orElse(null);

            if(null!=dmCzjbb){
                cjs=dmCzjbb.getCjs();
            }
            String cjs1=cjs;
            // 根据需求批量 船号 去 查询
            List<DmYdjh> ydjhs = dmYdjhService.list(new QueryWrapper<DmYdjh>().eq("dc_ch", slKc.getZYCH() ).eq("isnull(ZT,'')","2")
                .eq("dc_pl",slKc.getZYPL())
            );
                            DmYdjh dmYdjh = ydjhs.stream()
                .filter(fst -> fst.getDcCh().equalsIgnoreCase(slKc.getZYCH())
                    &&StringUtils.isNotBlank(fst.getWpgg())
                    &&  StringUtils.isNotBlank(fst.getWpxh())
                    && fst.getWpgg().equalsIgnoreCase(slKc.getWPGG())
                    && (fst.getWpxh().equalsIgnoreCase(slKc.getWPXH())
                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(slKc.getWPXH()))
                    && fst.getDcPl().equalsIgnoreCase(slKc.getZYPL())
                )
                .findFirst()
                .orElse(null);
                if(null!=dmYdjh){
                    dmYdjh.setSlkcdw(slKc.getKWH());
                    dmYdjh.setSlcs(slKc.getCFCS1());
                    dmYdjh.setSlxhth(slKc.getGCDDH());
                    dmYdjh.setSlhth(slKc.getDcFd());
                    dmYdjh.setNbsbm(slKc.getNBSBM());
                    dmYdjh.setSllph(slKc.getLPH());
                    dmYdjh.setSlwlh(slKc.getWPH());
                    dmYdjh.setKcch(slKc.getDCCH());
                    imCkwpkwp.setZylx(getLx(dmYdjh.getLqlb(), dmYdjh.getZl(),dmYdjh.getTzbh()));
                    imCkwpkwp.setSldw(dmYdjh.getKw());
                    imCkwpkwp.setDhh(dmYdjh.getSljhrq());
                    //slKc.setPwwz(dmYdjh.getKw());
                    imCkwpkwp.setYdid(dmYdjh.getId());
                    imCkwpkwp.setDcTh(dmYdjh.getTzbh());
                    ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
                    ups.add(dmYdjh);
                }

            }else{
                DmYdjh dmYdjh =new DmYdjh();
                dmYdjh.setSlkcdw(slKc.getKWH());
                dmYdjh.setSlcs(slKc.getCFCS1());
                dmYdjh.setSlxhth(slKc.getGCDDH());
                dmYdjh.setSlhth(slKc.getDcFd());
                dmYdjh.setNbsbm(slKc.getNBSBM());
                dmYdjh.setSllph(slKc.getLPH());
                dmYdjh.setSlwlh(slKc.getWPH());
                dmYdjh.setKcch(slKc.getDCCH());
                dmYdjh.setId(slKc.getYdid());
                ups.add(dmYdjh);
            }
            ups1.add(imCkwpkwp);
        }

        dmYdjhService.updateBatchById(ups);
        imCkwpkwpService.updateBatchByMultiId(ups1);

//        List<DmCbxxp> czList = dmCbxxpService.list();
//        List<DmYdjh>ydupList=new ArrayList<>();
//        List<DmYdjh>ydadList=new ArrayList<>();
//        List<SlKc>ckupList=new ArrayList<>();
//        // 进行比对
//        for(SlKc slKc :slKcs){
//            // 获取船级社
//            String cjs="";
//            DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(slKc.getDCCH())).findFirst().orElse(null);
//
//            if(null!=dmCzjbb){
//                cjs=dmCzjbb.getCjs();
//            }
//            String cjs1=cjs;
//            // 根据需求批量 船号 去 查询
//            List<DmYdjh> ydjhs = dmYdjhService.list(new QueryWrapper<DmYdjh>().eq("dc_ch", slKc.getZYCH() ).eq("isnull(ZT,'')","2")
//                .eq("dc_pl",slKc.getZYPL())
//            );
//            DmYdjh dmYdjh = ydjhs.stream()
//                .filter(fst -> fst.getDcCh().equalsIgnoreCase(slKc.getZYCH())
//                    &&StringUtils.isNotBlank(fst.getWpgg())
//                    &&  StringUtils.isNotBlank(fst.getWpxh())
//                    && fst.getWpgg().equalsIgnoreCase(slKc.getWPGG())
//                    && (fst.getWpxh().equalsIgnoreCase(slKc.getWPXH())
//                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(slKc.getWPXH()))
//                    && fst.getDcPl().equalsIgnoreCase(slKc.getZYPL())
//                )
//                .findFirst()
//                .orElse(null);
//
//            if(null!=dmYdjh){
//                System.out.println("slKc = " + slKc);
//
//                System.out.println(slKc.getCFCS1()+dmYdjh.getId());
//                dmYdjh.setSlkcdw(slKc.getKWH());
//                dmYdjh.setSlcs(slKc.getCFCS1());
//                dmYdjh.setSlxhth(slKc.getGCDDH());
//                dmYdjh.setSlhth(slKc.getDcFd());
//                dmYdjh.setSlwlh(slKc.getWPH());
//                dmYdjh.setKcch(slKc.getDCCH());
//                ydupList.add(dmYdjh);
//
//
//                slKc.setZYLX(getLx(dmYdjh.getLqlb(), dmYdjh.getZl()));
//                slKc.setSLDW(dmYdjh.getKw());
//                slKc.setDHH(dmYdjh.getSljhrq());
//                //slKc.setPwwz(dmYdjh.getKw());
//                slKc.setYdid(dmYdjh.getId());
//                slKc.setDCTH(dmYdjh.getTzbh());
//                ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
//                ckupList.add(slKc);
//            }else{
//                // 等于nul应该就是没有
//                // 新增月度计划
//                // 根据 月度计划新增一条信息。
//                // 获取
//                DmYdjh ydjhMin = dmYdjhMapper.getYdjhMin(slKc.getZYCH(), slKc.getZYPL());
//                if(null!=ydjhMin){
//                    DmYdjh ydjh =new DmYdjh();
//                    ydjh.setId(IdWorker.get32UUID());
//                    ydjh.setDcCh(slKc.getZYCH());
//                    ydjh.setDcPl(slKc.getZYPL());
//                    ydjh.setLx("B");
//                    ydjh.setWpgg(slKc.getWPGG());
//                    ydjh.setWpxh(slKc.getWPXH());
//                    ydjh.setSlrq(ydjhMin.getSlrq());
//                    ydjh.setPwrq(ydjhMin.getPwrq());
//                    ydjh.setHxrq(ydjhMin.getHxrq());
//                    ydjh.setQgrq(ydjhMin.getQgrq());
//                    ydjh.setDmrq(ydjhMin.getDmrq());
//                    ydjh.setQjgrq(ydjhMin.getQgjhrq());
//                    ydjh.setJssj(ydjhMin.getJssj());
//                    ydjh.setSljhrq(ydjhMin.getSljhrq());
//                    ydjh.setPwjhrq(ydjhMin.getPwjhrq());
//                    ydjh.setLljhrq(ydjhMin.getLljhrq());
//                    ydjh.setHxjhrq(ydjhMin.getHxjhrq());
//                    ydjh.setQgjhrq(ydjhMin.getQgjhrq());
//                    ydjh.setKw(extractNumber(slKc.getDcFd()));
//                    ydjh.setCkbzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
//                    ydjh.setCkbzry((String) req.getAttribute("yhms"));
//
//                    //------
//                    ydjh.setSlkcdw(slKc.getKWH());
//                    ydjh.setSlcs(slKc.getCFCS1());
//                    ydjh.setSlxhth(slKc.getGCDDH());
//                    ydjh.setSlhth(slKc.getDcFd());
//                    ydjh.setSlwlh(slKc.getWPH());
//                    ydjh.setKcch(slKc.getDCCH());
//                    slKc.setYdid(ydjh.getId());
//                    //ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
//                    ckupList.add(slKc);
//
//                    ydadList.add(ydjh);
//                    //-----
//                }else{
//                    throw new ServiceException(10001,slKc.getZYCH()+"船只"+slKc.getZYPL()+"未进行排产");
//                }
//
//            }
//
//
//        }
//        dmYdjhService.updateBatchById(ydupList);
//        dmYdjhService.saveBatch(ydadList);
//        for(SlKc slKc :slKcs){
//            ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
//            imCkwpkwp.setCkh(slKc.getCKH());
//            imCkwpkwp.setWph(slKc.getWPH());
//            imCkwpkwp.setKwh(slKc.getKWH());
//            imCkwpkwp.setNbsbm(slKc.getNBSBM());
//            imCkwpkwp.setYdid(slKc.getYdid());
//            imCkwpkwp.setZych(slKc.getZYCH());
//            imCkwpkwp.setZypl(slKc.getZYPL());
//            imCkwpkwp.setZylx(slKc.getZYLX());
//            imCkwpkwp.setSldw(slKc.getSLDW());
//            imCkwpkwp.setPwwz(slKc.getPwwz());
//            imCkwpkwp.setBz(slKc.getBZ());
//            imCkwpkwp.setDhh(slKc.getDHH());
//            imCkwpkwp.setDcTh(slKc.getDCTH());
//            imCkwpkwp.setYdid(slKc.getYdid());
//            imCkwpkwpService.updateByMultiId(imCkwpkwp);
//        }
        return new ResultBean();
    }


    public  String extractNumber(String str) {
        int hyphenIndex = str.indexOf('-');
        if (hyphenIndex != -1) {
            String substring = str.substring(hyphenIndex + 1);

            if(substring.equals("2N")){
                return "11";
            }
            if(substring.equals("2S")){
                return "5";
            }

            if(substring.equals("2")){
                return "9";
            }
            if(substring.equals("3S")){
                return "6";
            }
            if(substring.equals("3Q")){
                return "13";
            }
            if(substring.equals("4")){
                return "15";
            }
            if(substring.equals("7")){
                return "7-8";
            }

        }
        return ""; // Return empty string if hyphen is not found
    }
    @PostMapping("kcAdnSlZx")
    @ResponseBody
    public ResultBean kcAdnSlZx(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);
        String str1= JSON.toJSONString(map.get("data2"));
        List<DmYdjh>ydjhs= JSONObject.parseArray(str1, DmYdjh.class);


        List<DmYdjh>ydupList=new ArrayList<>();

        List<ImCkwpkwp>ckupList=new ArrayList<>();
        //String id = syService.f_getpjh("DM", "SYSTEM", "YLBH");
        for(SlKc slKc :slKcs){
            ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
                imCkwpkwp.setCkh(slKc.getCKH());
                imCkwpkwp.setWph(slKc.getWPH());
                imCkwpkwp.setKwh(slKc.getKWH());
                imCkwpkwp.setNbsbm(slKc.getNBSBM());
                imCkwpkwp.setYdid(slKc.getYdid());
                imCkwpkwp.setZych(slKc.getZYCH());
                imCkwpkwp.setZypl(slKc.getZYPL());
                imCkwpkwp.setZylx(slKc.getZYLX());
                imCkwpkwp.setSldw(slKc.getSLDW());
                imCkwpkwp.setPwwz(slKc.getPwwz());
                imCkwpkwp.setBz(slKc.getBZ());
                imCkwpkwp.setDhh(slKc.getDHH());
            ckupList.add(imCkwpkwp);
        }

        imCkwpkwpService.updateBatchByMultiId(ckupList);
        dmYdjhService.updateBatchById(ydjhs);
            return new ResultBean();
//

    }


    @PostMapping("/saveSljhPg")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPg(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPg(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgBack(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgBack(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXd(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXdBack(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveSljhPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhFk(list,req);
        return new ResultBean();
    }



//    @PostMapping("/getKcAndSljh")
//    @ResponseBody
//    @AuthFunction
//    public ResultBean getKcAndSljh(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
//        pgdSljhService.getKcAndSljh(list,req);
//        return new ResultBean();
//    }


    public  String getLx(String lqlb ,String zl,String tzbh){
//        1000	数中大
//        1001	数小
//        1002	数中
//        1003	数大
//        1004	数曲

//        1005	手小
//        1006	手中
//        1007	手大
//        1008	手中大
//        1009	焊接机器人肘板 --
        String mm="";
        if(tzbh.substring(4, 5).equals("S")){
            mm="手";
        }else if(tzbh.substring(4, 5).equals("N")){
            mm="数";
        }

//

            String bh = tzbh.substring(6, 8);  // 72
            if (tzbh.substring(4, 5).equals("X")) {   // 51
//                if ("XX".equalsIgnoreCase(bh)) {
//                    return "小组立";
//                } else if ("XD".equalsIgnoreCase(bh)) {
//                    return "中大组立";
//                }
                return "";
            } else {
                if ("XX".equalsIgnoreCase(bh)) {
                    return "1009"; // todo 小组
                }
            }
            String bh1 = tzbh.substring(7, 8);  // 81
            if ("X".equalsIgnoreCase(bh1)) {

                if(mm.equals("手")){
                    return "1005";
                }else if (mm.equals("数")){
                    return "1001";
                }
            }
            if ("D".equalsIgnoreCase(bh1)) {
               // return "中大组立";

                if(mm.equals("手")){
                    return "1008";
                }else if (mm.equals("数")){
                    return "1000";
                }
            }
            return "";


    }

    public String getwpcz(String wpcz){
        if(wpcz.contains("ABS")){
            return wpcz.replace("ABS","");
        }else if (wpcz.contains("ABS/CCS")){
            return wpcz.replace("ABS/CCS","");
        }else if (wpcz.contains("BV/CCS")){
            return wpcz.replace("BV/CCS","");
        }else if (wpcz.contains("CCS")){
            return wpcz.replace("CCS","");
        }else if (wpcz.contains("DNV")){
            return wpcz.replace("DNV","");
        }else if (wpcz.contains("DNV/CCS")){
            return wpcz.replace("DNV/CCS","");
        }else if (wpcz.contains("DNV/GL")){
            return wpcz.replace("DNV/GL","");
        }else if (wpcz.contains("LR")){
            return wpcz.replace("LR","");
        }else if (wpcz.contains("LR/CCS")){
            return wpcz.replace("LR/CCS","");
        }else {
            return wpcz;
        }

        //return wpcz;
    }

    @PostMapping("kcAdnSlBd2")
    @ResponseBody
    public ResultBean kcAdnSlBd2(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);
        
        boolean kwb= (boolean) map.get("flag");
        QueryWrapper<DmYdjh> qw =new QueryWrapper<>();
        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"dc_ch",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("dcpl")),"dc_pl",(String)map.get("dcpl"));
        qw.eq("isnull(ZT,'')","2").eq("isnull(slkcdw,'')","");
        qw.orderBy(true,true,"sljhrq");
        List<DmYdjh> ydjhs = dmYdjhService.list(qw);
         //库存标识 不等于 01 没有匹配上
        /***
         * ABS
         * ABS/CCS
         * BV/CCS
         * CCS
         * DNV
         * DNV/CCS
         * DNV/GL
         * LR
         * LR/CCS
         */




        List<DmCbxxp> czList = dmCbxxpService.list();
        List<DmYdjh>ydupList=new ArrayList<>();
        List<SlKc>ckupList=new ArrayList<>();
        // 进行比对
        for(SlKc slKc :slKcs){


            // 获取船级社
            String cjs="";
            DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(slKc.getDCCH())).findFirst().orElse(null);

            if(null!=dmCzjbb){
                cjs=dmCzjbb.getCjs();
            }
            if(StringUtils.isNotBlank(slKc.getZYCH())||StringUtils.isNotBlank(slKc.getZYPL()) ){
                continue;
            }
            String cjs1=cjs;
            DmYdjh dmYdjh = ydjhs.stream()
                .filter(fst -> fst.getDcCh().equalsIgnoreCase(slKc.getDCCH())
                    &&StringUtils.isNotBlank(fst.getWpgg())
                    &&  StringUtils.isNotBlank(fst.getWpxh())
                    && fst.getWpgg().equalsIgnoreCase(slKc.getWPGG())
                    && (fst.getWpxh().equalsIgnoreCase(slKc.getWPXH())
                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(slKc.getWPXH())
                    || ("DY".equalsIgnoreCase(slKc.getWPZT()) && getwpcz(slKc.getWPXH()).equalsIgnoreCase(fst.getWpxh())))
                )
                .findFirst()
                .orElse(null);

            if(null!=dmYdjh){
                System.out.println("slKc = " + slKc);
                dmYdjh.setSlkcdw(slKc.getKWH());
                System.out.println(slKc.getCFCS1()+dmYdjh.getId());
                dmYdjh.setSlcs(slKc.getCFCS1());
                dmYdjh.setSlxhth(slKc.getGCDDH());
                dmYdjh.setSlhth(slKc.getDcFd());
                dmYdjh.setNbsbm(slKc.getNBSBM());
                dmYdjh.setSllph(slKc.getLPH());
                dmYdjh.setSlwlh(slKc.getWPH());
                dmYdjh.setSlycldw((Integer) map.get("dw"));


                ydupList.add(dmYdjh);
                // ckupList.add(imCkwpkwp);



                slKc.setZYLX(getLx(dmYdjh.getLqlb(), dmYdjh.getZl(),dmYdjh.getTzbh()));
                slKc.setZYCH(dmYdjh.getDcCh());
                slKc.setZYPL(dmYdjh.getDcPl());
                slKc.setDCTH(dmYdjh.getTzbh());
                //  slKc.setZYLX(dmYdjh.getZl());
                if(kwb){

                    if(extractNumber(slKc.getDcFd()).equals("7-8")){
                        if((extractNumber(slKc.getDcFd()).contains(dmYdjh.getKw()))){
                            slKc.setSLDW(dmYdjh.getKw());
                        }
                    }else {
                        if(dmYdjh.getKw().equals(extractNumber(slKc.getDcFd()))){
                            slKc.setSLDW(dmYdjh.getKw());
                        }
                    }

                }else{
                    slKc.setSLDW(dmYdjh.getKw());
                }



                slKc.setDHH(dmYdjh.getSljhrq());
                //slKc.setPwwz(dmYdjh.getKw());
                slKc.setYdid(dmYdjh.getId());
                ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
                ckupList.add(slKc);
            }
            // 填写  库存垛位 kwh  层数  cfcs1  小合同号 gcddh    合同工 dc_fd   物料号 wph    炉批号  lph

        }
        Map retrunMap =new HashMap();
        retrunMap.put("slkcs",ckupList);
       // retrunMap.put("ydjhs",ydupList);
        return new ResultBean(retrunMap);
    }



    @PostMapping("kcAdnSlBdQX")
    @ResponseBody
    @Transactional(rollbackFor = Exception.class)
    public ResultBean kcAdnSlBdQX(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);

        //

        for(SlKc kc :slKcs){
            DmYdjh ydjh =new DmYdjh();
            // 库存主键 没存
            ydjh.setId(kc.getYdid());
            ydjh.setZt("2");
            ydjh.setSlkcdw("");
            ydjh.setSlcs("");
            ydjh.setSlxhth("");
            ydjh.setSlhth("");
            ydjh.setNbsbm("");
            ydjh.setSllph("");
            ydjh.setSlwlh("");
            ydjh.setKcch("");

            dmYdjhService.updateById(ydjh);

            ImCkwpkwp imCkwpkwp =new ImCkwpkwp();

            imCkwpkwp.setCkh(kc.getCKH());
            imCkwpkwp.setWph(kc.getWPH());
            imCkwpkwp.setKwh(kc.getKWH());
            imCkwpkwp.setNbsbm(kc.getNBSBM());
            imCkwpkwp.setZylx("");
            imCkwpkwp.setZych("");
            imCkwpkwp.setZypl("");
            imCkwpkwp.setDcTh("");
            imCkwpkwp.setSldw("");
            imCkwpkwp.setDhh("");
            //slKc.setPwwz(dmYdjh.getKw());
            imCkwpkwp.setYdid("");
            imCkwpkwpService.updateByMultiId(imCkwpkwp);


        }

        return new ResultBean();
    }
}

