package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmDhqdp;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.DmSygdxqOld;
import com.dsic.gj_erp.exception.ServiceException;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmDhqdpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqOldService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@Service
public class DmSygdxqServiceImpl extends ServiceImpl<DmSygdxqMapper, DmSygdxq> implements DmSygdxqService {

    @Autowired
    DmSygdxqOldService  oldService;
    @Autowired
    DmSygdMxService sygdMxService;
    @Autowired
    DmBomService bomService;
    @Autowired
    DmCbxxpService dmCbxxpService;
    @Autowired
    DmDhqdpService dhqdpService;


    @Override
    @Transactional
    public void saveXzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                //存进备份表
                DmSygdxqOld old=  BeanUtil.copyProperties(sygdxq, DmSygdxqOld.class);
                oldService.save(old);
                l.setDrcs(sygdxq.getDrcs()+1);
                l.setXzglxqOld(sygdxq.getXzglxq());
                l.setDrr(username);
                l.setDrrq(day);
                //状态 2拖期 1提前
                if (ObjUtil.isAllNotEmpty(sygdxq.getXzglxq(),l.getXzglxq())){
                    if (sygdxq.getXzglxq()!=null&&l.getXzglxq().compareTo(sygdxq.getXzglxq())>0){
                        l.setXqzt("2");
                    }
                    if (sygdxq.getXzglxq()!=null&&l.getXzglxq().compareTo(sygdxq.getXzglxq())<0){
                        l.setXqzt("1");
                    }
                    this.update(new UpdateWrapper<DmSygdxq>()
                            .set("xzglxq",l.getXzglxq())
                            .set("xzglxq_old",l.getXzglxqOld())
                            .set("xdb",l.getXdb())
                            .set("xskj",l.getXskj())
                            .set("xpt",l.getXpt())
                            .set("xyw",l.getXyw())
                            .set("xxc",l.getXxc())
                            .set("xtxc",l.getXtxc())
                            .set("drcs",l.getDrcs())
                            .set("xqzt",l.getXqzt())
                            .set("drrq",l.getDrrq())
                            .set("drr",l.getDrr())
                            .eq("dc_ch",l.getDcCh())
                            .eq("dc_pl",l.getDcPl())
                            .eq("DC_FD",l.getDcFd())
                    );
                    //todo 修正三月滚动
                    correctSygdmx(l.getDcCh(),l.getDcPl(),l.getDcFd(),l.getXzglxq());
                }
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
        });
    }

    @Override
    @Transactional
    public void saveDzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                l.setDrr(username);
                l.setDrrq(day);
                this.update(new UpdateWrapper<DmSygdxq>()
                        .set("dzglxq",l.getDzglxq())
                        .set("dzglxq_old",sygdxq.getDzglxq())
                        .set("dqb",l.getDqb())
                        .set("dxc",l.getDxc())
                        .set("dsj",l.getDsj())
                        .set("ddb",l.getDdb())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
        });

    }

    @Override
    public List<DmSygdxq> getXqWithBom(String from, String to) {
        return t(from,to,"","");
    }

    @Override
    public List<DmSygdxq> getXqWithBom2(String from, String to) {
        return t2(from,to,"","");
    }

    private List<DmSygdxq> t(String from, String to,String dcch,String pl){
        List<DmSygdxq> xqWithBom = baseMapper.getXqWithBom(from, to, dcch, pl);
        for (DmSygdxq xq : xqWithBom) {
            if (ObjUtil.isEmpty(xq.getBomList())){
                //从系列船取bom
                //获取系列船信息
                DmCbxxp one = dmCbxxpService.getOne(Wrappers.<DmCbxxp>lambdaQuery()
                        .eq(DmCbxxp::getCbbm, xq.getDcCh())
                );

                if (one!=null){
                    List<DmBom> bomList = bomService.list(Wrappers.<DmBom>lambdaQuery()
                            .eq(DmBom::getDcch, xq.getDcCh())
                            .eq(DmBom::getPl, xq.getDcPl())
                            .eq(DmBom::getFd, xq.getDcFd())
                    );
                    bomList.forEach(item->item.setDcch(xq.getDcCh()));//系列船获取bom船号修正为当前船只
                    xq.setBomList(bomList);
                }else{//bom不存在从订货清单获取数据
                    List<DmDhqdp> list = dhqdpService.list(Wrappers.<DmDhqdp>lambdaQuery().eq(DmDhqdp::getDcCh, xq.getDcCh()));
                    List<DmDhqdp> collect = list.stream().filter(item -> item.getPlzlsl().contains(pl)).collect(Collectors.toList());

                    List<DmBom> bomList=new ArrayList<>();
                    collect.forEach(item->{
                        if (item.getKdzlsl()==null){
                            return;
                        }
                        String[] kdzlsls=item.getKdzlsl().split("/");

                        for (String kdzlsl:kdzlsls){
                            Optional.ofNullable(kdzlsl).ifPresent(it->{
                                String kd= String.valueOf(it.charAt(1));
                                String kw= String.valueOf(it.charAt(0));
                                String kw4= String.valueOf(it.charAt(2));
                                String zl=String.valueOf(it.charAt(3));
                                String sl=kdzlsl.split("=")[1];
                                try {
                                    int slI = Integer.parseInt(sl);
                                    for (int i=0;i<slI;i++){
                                        DmBom bom = new DmBom();
                                        bom.setDcch(dcch);
                                        bom.setPl(pl);
                                        bom.setWpcz(item.getWpxh());
                                        bom.setWpgg(StrUtil.format("{}*{}*{}",item.getThickness(),item.getWidth(),item.getLength()));

                                        switch (kd){
                                            case "1":
                                                this.handlerFor1(bom,zl,kw,kw4);
                                                break;
                                            case "2":
                                                this.handlerFor2(bom,zl,kw,kw4);
                                                break;
                                            case "3":
                                                this.handlerFor3(bom,zl,kw,kw4);
                                                break;
                                            case "4":
                                                this.handlerFor4(bom,zl,kw,kw4);
                                                break;
                                            case "7"://型材
                                                this.handlerFor7(bom,zl,kw,kw4);
                                                break;
                                            case "8"://光电
                                                this.handlerFor8(bom,zl,kw,kw4);
                                                break;
                                        }
                                        bomList.add(bom);
                                    }
                                }catch (Exception ignored){}
                            });
                        }
                    });
                    xq.setBomList(bomList);
                }
                if (ObjUtil.isEmpty(xq.getBomList())){
                    //throw new ServiceException(10001,StrUtil.format("船只:{},批次{}无法从系列船或订货清单获取基础数据,请先核对数据后再次排产!",xq.getDcCh(),xq.getDcPl()));
                }
            }
        }

        return xqWithBom;
    }

    private void handlerFor1(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1010");
        }
        if ("D".equals(zl)){
            bom.setZl("1110");
        }
        if ("N".equals(kw)&&"A".equals(kw4)){
            bom.setKw("7");
        }
        if ("N".equals(kw)&&"L".equals(kw4)){
            bom.setKw("8");
        }
    }

    private void handlerFor2(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1010");
        }
        if ("D".equals(zl)){
            bom.setZl("1110");
        }
        if ("S".equals(kw)&&"T".equals(kw4)){
            bom.setKw("5");
        }
        if ("N".equals(kw)&&"B".equals(kw4)){
            bom.setKw("9");
        }
        if ("N".equals(kw)&&"C".equals(kw4)){
            bom.setKw("10");
        }
        if ("N".equals(kw)&&"T".equals(kw4)){
            bom.setKw("11");
        }
        if ("N".equals(kw)&&"J".equals(kw4)){
            bom.setKw("12");
        }
    }

    private void handlerFor3(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1010");
        }
        if ("D".equals(zl)){
            bom.setZl("1110");
        }
        if ("X".equals(zl)){
            bom.setZl("4230");
        }
        if ("S".equals(kw)&&"P".equals(kw4)){
            bom.setKw("6");
        }
        if ("S".equals(kw)&&"X".equals(kw4)){
            bom.setKw("6");
        }
        if ("N".equals(kw)&&"C".equals(kw4)){
            bom.setKw("13");
        }
        if ("N".equals(kw)&&"H".equals(kw4)){
            bom.setKw("14");
        }
    }

    private void handlerFor4(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1010");
        }
        if ("D".equals(zl)){
            bom.setZl("1110");
        }
        if ("X".equals(zl)){
            bom.setZl("4230");
        }
        if ("N".equals(kw)&&"P".equals(kw4)){
            bom.setKw("15");
        }
        if ("N".equals(kw)&&"X".equals(kw4)){
            bom.setKw("15");
        }
    }

    private void handlerFor7(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1010");
        }
        if ("D".equals(zl)){
            bom.setZl("1110");
        }
        if ("X".equals(kw)&&"X".equals(kw4)){
            bom.setKw("16");
        }
    }

    private void handlerFor8(DmBom bom,String zl,String kw,String kw4){
        if ("X".equals(zl)){
            bom.setZl("1120");
        }
        if ("N".equals(kw)&&"G".equals(kw4)){
            bom.setKw("17");
        }
    }

    private List<DmSygdxq> t2(String from, String to,String dcch,String pl){
        return baseMapper.getXqWithBom2(from,to,dcch,pl);
    }

    //零件信息
    public void correctSygdmx(String ch,String pl,String fd,String xqsj){
        //根据：本次导入的三月需求期 提取BOM 生成三月需求零件信息
       List<DmSygdMx> list= sygdMxService.list(new QueryWrapper<DmSygdMx>()
               .eq("dc_ch",ch)
               .eq("dc_pl",pl)
               .in("tzbh"," SELECT dm_bom.tzbh FROM dm_bom WHERE dm_bom.dcch='"+ch+"' and dm_bom.pl='"+pl+"' and dm_bom.fd='"+fd+"'"));
      DateTime dateTime= DateUtil.parse(xqsj,"yyyy/MM/dd");
       list.forEach(l->{
           l.setJssj(xqsj);
           l.setSlrq(DateUtil.offsetDay(dateTime,-9).toString());//8
           if (l.getKw().equals("16")){//型材
               l.setPwrq(DateUtil.offsetDay(dateTime,-5).toString());//4
           }else {
               l.setPwrq(DateUtil.offsetDay(dateTime,-8).toString());//7
           }

            l.setHxrq(DateUtil.offsetDay(dateTime,-3).toString());//2
            l.setQgrq(DateUtil.offsetDay(dateTime,-3).toString());//2
           sygdMxService.save(l);
        });

    }
}

